from tiviwiki import app
from flask import g
import MySQLdb

def connect_db():
    return MySQLdb.connect(host=app.config['DATABASE_HOST'],
                           user=app.config['DATABASE_USER'],
                           passwd=app.config['DATABASE_PASS'],
                           db=app.config['DATABASE'],
                           charset='utf8',
                           use_unicode=True)

@app.before_request
def before_request():
    if hasattr(g, 'db'):
        return

    g.db = connect_db()

@app.teardown_request
def teardown_request(exception):
    if hasattr(g, 'db'):
        g.db.close()

def query_db(query, args=(), one=False):
    g.cur = g.db.cursor()
    g.cur.execute(query, args)
    g.db.commit()
    rv = [dict((g.cur.description[idx][0], value)
               for idx, value in enumerate(row)) for row in g.cur.fetchall()]
    return (rv[0] if rv else None) if one else rv 

def affected_rows():
    if hasattr(g, 'cur'):
        return g.cur.rowcount
    return 0
